﻿@model eCommerce.BackOffice.ViewModels.OrdersListPageViewModel

@using eCommerce.Services.Model.Enums
@{
    ViewBag.Title = "Ventas";
    Layout = "~/Views/Shared/_ListLayout.cshtml";
}

<style>
    .js-UpdateOrderPaymentStatus,
    .js-UpdateOrderDeliveryStatus,
    .js-UpdateOrderStatus {
        cursor: pointer;
    }
</style>

<div class="page-header">
    <div class="paddding-0" style="margin-left:-30px;display:inline;">
        <div class="form-group col-md-2">
            <div class="input-group">
                <span class="input-group-addon"><i class="icon wb-calendar" aria-hidden="true"></i></span>
                <input type="text" class="form-control DateInput" id="fromDate" placeholder="Desde" value="@Model.FromDate" />
            </div>
        </div>
        <div class="form-group col-md-2">
            <div class="input-group">
                <span class="input-group-addon"><i class="icon wb-calendar" aria-hidden="true"></i></span>
                <input type="text" class="form-control DateInput" id="toDate" placeholder="Hasta" value="@Model.ToDate" />
            </div>
        </div>
        <div class="col-md-2">
            <button type="button" class="btn btn-outline btn-primary" onclick="GetOrders()">FILTRAR</button>
        </div>
    </div>

    <div class="page-header-actions">

        @*<div class="btn-group btn-group-sm" id="withBtnGroup" aria-label="Page Header Actions" role="group">
                <button type="button" class="btn btn-outline btn-primary" onclick="window.location.href = '/Orders/DeletedOrders'">
                    <i class='icon wb-trash' aria-hidden='true'></i>
                    <span class="hidden-xs">VENTAS BORRADAS</span>
                </button>
            </div>*@

        <div class="btn-group btn-group-sm" id="withBtnGroup" aria-label="Page Header Actions" role="group">
            <button type="button" class="btn btn-outline btn-primary" onclick="OpenModal()">
                <i class="icon fa-search" aria-hidden="true"></i>
                <span class="hidden-xs">BUSCAR POR PRODUCTO</span>
            </button>
        </div>

        <div class="btn-group btn-group-sm" id="withBtnGroup" aria-label="Page Header Actions" role="group">
            <button type="button" class="btn btn-outline btn-primary" onclick="window.location.href = '/Orders/OrderUpdate/-1'">
                <i class="icon wb-plus" aria-hidden="true"></i>
                <span class="hidden-xs">NUEVA VENTA</span>
            </button>
        </div>

    </div>
</div>

<div class="page-content">

    <div class="row ">

    </div>

    <div class="panel">
        <div class="panel-body">
            <table class="table table-hover dataTable table-striped width-full" id="dtOrders">
                <thead>
                    <tr>
                        <th class="text-center" style="width:20px;">#Id</th>
                        <th class="text-center">Fecha</th>
                        <th class="text-left">Tienda</th>
                        <th class="text-left">Canal</th>
                        <th class="text-left">F. Entrega</th>
                        <th class="text-left">F. Pago</th>
                        <th class="text-center" nowrap="nowrap">Total ($)</th>
                        <th class="text-center">Cobro</th>
                        <th class="text-center">Entrega</th>
                        <th class="text-center">Estado</th>
                        <th class="text-center" nowrap="nowrap">Acciones</th>
                    </tr>
                </thead>
            </table>
        </div>
    </div>

</div>

<div class="modal fade" id="SearchByProduct" aria-hidden="false" aria-labelledby="checks" role="dialog" tabindex="-1">
    <div class="modal-dialog" style="width:1000px;">
        <form class="modal-content" id="modalSearchByProduct" method="post" action="#">
            <div class="modal-header">
                <button type="button" class="close" data-dismiss="modal" aria-label="Close">
                    <span aria-hidden="true">×</span>
                </button>
                <h4 class="modal-title" id="exampleFormModalLabel">Busqueda de pedidos por producto</h4>
            </div>
            <div class="modal-body">
                <input type="text" class="form-control" id="ProductCode" value="" placeholder="Código de producto" />
                <button type="submit" class="btn btn-primary" id="btnSearchByProduct" onclick="searchByProduct()" style="margin-top:5px;float:right;">Buscar</button>
                <h5 id="errorMsg" style="display:none;"></h5>

                <div id="SearchedProductList" class="row">
                </div>
            </div>
        </form>
    </div>
</div>

<div class="modal fade" id="StoreAsign" aria-hidden="false" aria-labelledby="checks" role="dialog">
    <div class="modal-dialog">
        <form class="modal-content" id="modalStoreAsign" method="post" action="#">
            <div class="modal-header">
                <button type="button" class="close" data-dismiss="modal" aria-label="Close">
                    <span aria-hidden="true">×</span>
                </button>
                <h4 class="modal-title" id="exampleFormModalLabel">Asignación de pedido a local</h4>
            </div>
            <div class="modal-body">
                <select class="form-control" id="StoreList" style="width:100%;"></select>
            </div>
            <div class="modal-footer">
                <input type="hidden" id="ModalOrderId" />
                <button type="button" class="btn btn-default" data-dismiss="modal">Cancelar</button>
                <button type="button" class="btn btn-primary" onclick="ConfirmStoreAssignation()">Asignar y enviar mail</button>
            </div>
        </form>
    </div>
</div>

<style type="text/css">
    .select2-close-mask {
        z-index: 2099;
    }

    .select2-dropdown {
        z-index: 3051;
    }
</style>

@section Scripts {

    <script type="text/javascript">

        $(document).ready(function () {
            bindOrders();
        })

        function GetOrders() {
            if ($('#fromDate').val() != null && $('#fromDate').val() != "" && $('#toDate').val() != null && $('#toDate').val() != "" && moment($('#toDate').val(), "DD/MM/YYYY") < moment($('#fromDate').val(), "DD/MM/YYYY")) {
                toastr.warning("Ingrese una fecha desde menor a fecha hasta.");
            }
            else {
                $("#loadingDiv").show();
                bindOrders();
            }
        }

        function fCancel(Id) {
            $.ajax({
                url: "/Orders/OrderCancel/" + Id,
                type: "GET",
                data: null,
                success: function (data, textStatus, jqXHR) {
                    if (data.Error != "") {
                        swal(data.Error, "", "warning");
                    }
                    else {
                        var canceled_label = '<span class="label label-dark">CANCELADA</span>';
                        $("[data-rowid='" + Id + "']").closest("td").prev().html(canceled_label);

                        var remove_label = '<a href="javascript:void(0);" class="btn btn-sm btn-icon btn-pure btn-default on-default remove-row" data-toggle="tooltip" data-original-title="Eliminar" data-rowid="' + Id + '" onclick="fDeleteDialog(' + Id + ')"><i class="icon wb-trash" aria-hidden="true"></i></a>';

                        var action_td = $("[data-rowid='" + Id + "']").closest("td");
                        $($("[data-rowid='" + Id + "']")[1]).remove();
                        action_td.append(remove_label);

                        swal("La venta fue cancelada correctamente.", "", "success");
                    }
                }
            });
        }

        function fDelete(Id) {
            $.ajax({
                url: "/Orders/OrderDelete/" + Id,
                type: "GET",
                data: null,
                success: function (data, textStatus, jqXHR) {
                    if (data.Error != "") {
                        swal(data.Error, "", "warning");
                    }
                    else {
                        $("[data-rowid='" + Id + "']").closest("tr").remove()
                        swal("La venta fue borrada correctamente.", "", "success");
                    }
                }
            });
        }

        function fSendMail(Id) {
            $.ajax({
                url: "/Orders/OrderSendMail/" + Id,
                type: "GET",
                data: null,
                success: function (data) {
                    if (data == '') {
                        swal("Enviado!", "", "success");
                    }
                }
            });
        }

        function fCancelDialog(orderId) {
            var orderId = orderId;
            swal({
                title: "Cancelar Venta",
                text: "Seguro que desea cancelar la venta #" + orderId + "?",
                type: "warning",
                showCancelButton: true,
                confirmButtonColor: '#F26A54',
                confirmButtonText: 'Sí, deseo cancelarla',
                cancelButtonText: 'No',
                closeOnConfirm: false,
                closeOnCancel: true
            },
            function (isConfirm) {
                if (isConfirm) {
                    //deshabilitar.
                    //$(".confirm").attr('disabled', 'true');
                    fCancel(orderId);
                }
            });

        }

        function fDeleteDialog(orderId) {
            var orderId = orderId;
            swal({
                title: "Esta seguro que desea Eliminar la venta #" + orderId + " ?",
                text: "",
                type: "warning",
                showCancelButton: true,
                confirmButtonColor: '#F26A54',
                confirmButtonText: 'Sí, deseo elminarlo!',
                cancelButtonText: 'Cancelar',
                closeOnConfirm: false,
                closeOnCancel: true
            },
            function (isConfirm) {
                if (isConfirm) {
                    fDelete(orderId);
                }
            });
        }

        function fSendMailDialog(orderId) {
            var orderId = orderId;
            swal({
                title: "Reenviar Orden de Compra",
                text: "Esta seguro que desea enviar el mail de de la Orden #" + orderId + " ?",
                type: "warning",
                showCancelButton: true,
                confirmButtonColor: '#F26A54',
                confirmButtonText: 'Sí, deseo enviarlo',
                cancelButtonText: 'No',
                closeOnConfirm: false,
                closeOnCancel: true
            },
            function (isConfirm) {
                if (isConfirm) {
                    fSendMail(orderId);
                }
            });
        }

        function OpenModal(rmaId, rmaItemId) {
            $("#SearchByProduct").modal();
        }

        function ConfirmStoreAssignation() {
            var storeId = $("#StoreList").val();
            if (storeId == null || storeId == "") {
                toastr.warning("Seleccione un local");
                return null;
            }

            var storeName = $("#StoreList option:selected").text();
            var orderId = $("#ModalOrderId").val();

            swal({
                title: "Asignar Local",
                text: "Esta seguro que desea asignar el pedido y enviar el mail al local " + storeName + "?",
                type: "warning",
                showCancelButton: true,
                confirmButtonColor: '#F26A54',
                confirmButtonText: 'Sí, deseo asignarlo',
                cancelButtonText: 'No',
                closeOnConfirm: false,
                closeOnCancel: true
            },
            function (isConfirm) {
                if (isConfirm) {
                    fConfirmStoreAssignation(orderId, storeId);
                    swal("El local fue asignado y el mail enviado correctamente.", "", "success");
                }
            });
        }

        function fConfirmStoreAssignation(orderId, storeId) {
            $.ajax({
                url: "/Orders/SendStoreMail",
                type: "POST",
                data: { OrderId: orderId, StoreId: storeId },
                success: function (data, textStatus, jqXHR) {
                    $("#StoreAsign").modal('hide')
                }
            });
        }

        function searchByProduct() {
            event.preventDefault();
            var productCode = $("#ProductCode").val();
            if (productCode != "") {
                $.ajax({
                    url: "/Orders/SearchByProduct/?productCode=" + productCode,
                    type: "GET",
                    data: null,
                    success: function (data, textStatus, jqXHR) {
                        $('#SearchedProductList').html(data);
                        $("#errorMsg").css("display", "none");
                        $("#SearchedProductList").css("display", "block");
                    }
                });
            }
            else {
                $("#SearchedProductList").css("display", "none");
                $("#errorMsg").css("display", "block");
                $("#errorMsg").text("Ingrese un código de producto");
            }
        }


        function bindOrders() {
            var datatable = $('#dtOrders').DataTable({
                ajax: {
                    url: "/Orders/GetOrders",
                    type: "GET",
                    data: { from: $('#fromDate').val(), to: $('#toDate').val() }
                },
                "initComplete": function () {
                    $("#loadingDiv").hide();
                },
                destroy: true,
                deferRender: true,
                columns: [
                    { "data": "OrderId", "orderable": true },
                    { "data": "CreatedDateStr", "type": "date-arg", "className": "text-center", "orderable": true },
                    { "data": "CustomerName", "className": "text-left", "orderable": true },
                    { "data": "ChannelLabel", "className": "text-left", "orderable": true },
                    { "data": "DeliveryMethodLabel", "className": "text-left", "orderable": true },
                    { "data": "PaymentMethodLabel", "className": "text-left", "orderable": true },
                    { "data": "TotalLabel", "type": "currency", "className": "text-right no-wrap", "orderable": true }, //No se filtra bien
                    { "data": "PaymentStatusLabel", "className": "js-UpdateOrderPaymentStatus text-center no-wrap", "orderable": true },
                    { "data": "DeliveryStatusLabel", "className": "js-UpdateOrderDeliveryStatus text-center no-wrap", "orderable": true },
                    { "data": "OrderStatusLabel", "className": "text-center no-wrap", "orderable": true },
                    {
                        "className": "text-center no-wrap",
                        "render": function (data, type, full, meta) {
                            var actions = "";
                            //Order Update
                            actions += "<a href = '/Orders/OrderUpdate/" + full.OrderId + "' target ='_blank' class='btn btn-sm btn-icon btn-pure btn-default on-default edit-row' data-toggle='tooltip' data-original-title='Editar'><i class='icon wb-edit' aria-hidden='true'></i></a>";
                            //Enviar Resumen de Venta
                            actions += "<a href='javascript: void(0);' class='btn btn-sm btn-icon btn-pure btn-default on-default sendmail-row' data-toggle='tooltip' data-original-title='Enviar Resumen de Venta' data-rowid='" + full.OrderId + "' onclick='fSendMailDialog(" + full.OrderId + ")'><i class='icon fa-envelope-o' aria-hidden='true'></i></a>";
                            //Cobros
                            actions += "<a href='/CustomerAccounting?Id=" + full.CustomerId + "' class='btn btn-sm btn-icon btn-pure btn-default on-default' data-toggle='tooltip' data-original-title='Cobros'><i class='icon fa-money' aria-hidden='true'></i></a>";
                            //Entregas
                            actions += "<a href='/DeliveryOrders/DeliveryOrderList/" + full.OrderId + "' target='_blank' class='btn btn-sm btn-icon btn-pure btn-default on-default edit-row' data-toggle='tooltip' data-original-title='Entregas'><i class='icon fa-bus' aria-hidden='true'></i></a>";
                            //Orden Impresa
                            actions += "<a href='/Orders/OrderPrint/" + full.OrderId + "' target='_blank' class='btn btn-sm btn-icon btn-pure btn-default on-default edit-row' data-toggle='tooltip' data-original-title='Imprimir' target='_blank'><i class='icon fa-print' aria-hidden='true'></i></a>";

                            //Acción de Cancelar/Eliminar según el estado de la venta
                            if (full.OrderStatusId != "@((int)OrderStatusEnum.Cancelada)") {
                                //Cancelar
                                actions += "<a href='javascript: void(0); 'class='btn btn-sm btn-icon btn-pure btn-default on-default cancel-row' data-toggle='tooltip' data-original-title='Cancelar' data-rowid='" + full.OrderId + "' onclick='fCancelDialog(" + full.OrderId + ")'><i class='icon fa-ban' aria-hidden='true'></i></a>";
                            } else {
                                //Eliminar
                                actions += "<a href='javascript:void(0);' class='btn btn-sm btn-icon btn-pure btn-default on-default remove-row' data-toggle='tooltip' data-original-title='Eliminar' data-rowid='" + full.OrderId + "' onclick='fDeleteDialog(" + full.OrderId + ")'><i class='icon wb-trash' aria-hidden='true'></i></a>";
                            }

                            //Pago Online
                            if (full.PaymentMethodId == "@((int)PaymentMethodEnum.Decidir)") {
                                actions += "<a href='" + full.PagoOnlineUrl + "' target='_blank' class='btn btn-sm btn-icon btn-pure btn-default on-default edit-row' data-toggle='tooltip' data-original-title='Link de Pago' target='_blank'><i class='icon fa-credit-card' aria-hidden='true'></i></a>";
                            }

                            return actions;
                        }
                    }
                ]
            });

            $("#dtOrders").tooltip({
                selector: '[data-toggle="tooltip"]'
            });
        }




        //cambiar estado de entrega.
        $("#dtOrders").on("dblclick", ".js-UpdateOrderDeliveryStatus", function UpdateOrderPaymentStatus() {
            debugger;
            var parent = $(this).parent().closest('tr').children('td:first').text();
            var Id = parseInt(parent);

            $(this).addClass("js-delivery-status-" + Id);

            $('.js-delivery-status-' + Id).html("<img src='/Content/assets/images/ajax-loader.gif' style='height:16px' />");

            $.ajax({
                url: "/Orders/UpdateOrderDeliveryStatus/" + Id,
                type: "GET",
                data: null,
                success: function (data, textStatus, jqXHR) {
                    if (!data.Error) {
                        let new_status = "";
                        if (data.Status == "@((int)DeliveryStatusEnum.Pendiente)") {
                            new_status = "<span class='label label-outline label-danger'>A ENTREGAR</span>";
                        }
                        else {
                            new_status = "<span class='label label-outline label-success'>ENTREGADO</span>";
                        }
                        setTimeout(function () { $('.js-delivery-status-' + Id).html(new_status) }, 400);
                    }
                }
            });

        });

        //cambiar estado de cobro.
        $("#dtOrders").on("dblclick", ".js-UpdateOrderPaymentStatus", function UpdateOrderPaymentStatus() {
            debugger;
            var parent = $(this).parent().closest('tr').children('td:first').text();
            var Id = parseInt(parent);

            $(this).addClass("js-payment-status-" + Id);

            $('.js-payment-status-' + Id).html("<img src='/Content/assets/images/ajax-loader.gif' style='height:16px' />");

            $.ajax({
                url: "/Orders/UpdateOrderPaymentStatus/" + Id,
                type: "GET",
                data: null,
                success: function (data, textStatus, jqXHR) {
                    if (!data.Error) {
                        let new_status = "";
                        if (data.Status == "@((int)PaymentStatusEnum.Pendiente)") {
                            new_status = "<span class='label label-outline label-danger'>A COBRAR</span>";
                        }
                        else {
                            new_status = "<span class='label label-outline label-success'>COBRADA</span>";
                        }

                        setTimeout(function () { $('.js-payment-status-' + Id).html(new_status) }, 400);
                    }
                }
            });
        });

        //cambiar estado de Orden.
        $("#dtOrders").on("dblclick", ".js-UpdateOrderStatus", function UpdateOrderStatus() {
            debugger;
            var parent = $(this).parent().closest('tr').children('td:first').text();
            var Id = parseInt(parent);

            $(this).addClass("js-order-status-" + Id);

            $('.js-order-status-' + Id).html("<img src='/Content/assets/images/ajax-loader.gif' style='height:16px' />");

            $.ajax({
                url: "/Orders/UpdateOrderStatus/" + Id,
                type: "GET",
                data: null,
                success: function (data, textStatus, jqXHR) {
                    if (!data.Error) {
                        debugger;
                        let new_status = "";
                        if (data.Status == "@((int)OrderStatusEnum.EnProceso)") {
                            new_status = "<span class='label label-outline label-warning'>EN PROCESO</span>";
                        }
                        else {
                            new_status = "<span class='label label-outline label-primary'>CONFIRMADO</span>";
                        }

                        setTimeout(function () { $('.js-order-status-' + Id).html(new_status) }, 400);
                    }
                }
            });
        });

    </script>

}

